(define merge-sort 
  (lambda (cmp xs)
    (define merge 
      (lambda (xs ys)
	(cond 
	 ((null? xs) ys)
	 ((null? ys) xs)
	 ((cmp (car xs) (car ys))
	  (cons (car xs) (merge (cdr xs) ys)))
	 (else (cons (car ys) (merge xs (cdr ys))))
	 )))
    (define split
      (lambda (xs)
	(if (null? xs)
	    '(() ())
	    (let ((subsplit (split (cdr xs))))
	      (list (cons (car xs) (second subsplit))
		    (first subsplit))))))
    (define msort
      (lambda (zs)
	(if (or (null? zs) (null? (cdr zs)))
	    zs
	    (let ((halves (split zs)))
	      (merge (msort (first halves))
		     (msort (second halves)))))))
    (msort xs)))


